/*!
 * @file      RecvMemoDlg.h
 * @brief      ޱ â.
 * @author    Yangjae.park(yangjae.park@nhn.com)
 * @date      2012-01-27 
 * @warning   
 */
#pragma once
#include "SkinDialog.h"
#include "afxwin.h"
#include "afxhtml.h"
#include "afxcmn.h"
#include "AtatchDownload.h"
#include "MemoSendDlg.h"
#include "MenuXP.h"
#include "MemoView_explorer.h"
#include "MemoListCtrl.h"
#include "MemoRecvAttachWnd.h"

// ̾α  ÷  [2012.4.9 yangjae.park@nhn.com]
#define COMMON_EDIT_BORDER_COLOR			RGB(201,201,201)
#define COMMON_BG_COLOR						RGB(238,239,51)
#define COMMON_TEXT_COLOR					RGB(34,34,34)
#define TOP_BK_COLOR						RGB(230,233,238)
#define COMMON_BORDER_COLOR					RGB(203,207,215)

// ʱ ̾α   [2012.4.9 yangjae.park@nhn.com]
#define RMD_DEF_MIN_SIZE_WIDTH				(560)
#define RMD_DEF_MIN_SIZE_HEIGHT				(480)
#define RMD_DEF_TITLE_BAR_HEIGHT			(26)

// ư 
#define RMD_DEF_TOP_BK_POS_X				(0)
#define RMD_DEF_TOP_BK_POS_Y				(0)
#define RMD_DEF_TOP_BK_POS_WIDTH			(0)
#define RMD_DEF_TOP_BK_POS_HEIGHT			(33)

//ϴ 
#define RMD_DEF_REPLY_BUTTON_POS_X			(20)
#define RMD_DEF_REPLY_BUTTON_POS_Y			(30-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_REPLY_BUTTON_WIDTH			(90)
#define RMD_DEF_REPLY_BUTTON_HEIGHT			(27)

#define RMD_DEF_ALL_REPLY_BUTTON_POS_X		(110)
#define RMD_DEF_ALL_REPLY_BUTTON_POS_Y		(30-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_ALL_REPLY_BUTTON_WIDTH		(90)
#define RMD_DEF_ALL_REPLY_BUTTON_HEIGHT		(27)


#define RMD_DEF_FORWARD_BUTTON_POS_X		(200)
#define RMD_DEF_FORWARD_BUTTON_POS_Y		(30-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_FORWARD_BUTTON_WIDTH		(90)
#define RMD_DEF_FORWARD_BUTTON_HEIGHT		(27)

#define RMD_DEF_DEL_BUTTON_POS_X			(290)
#define RMD_DEF_DEL_BUTTON_POS_Y			(30-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_DEL_BUTTON_WIDTH			(90)
#define RMD_DEF_DEL_BUTTON_HEIGHT			(27)

#define RMD_DEF_IM_BUTTON_POS_X				(380)
#define RMD_DEF_IM_BUTTON_POS_Y				(30-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_IM_BUTTON_WIDTH				(90)
#define RMD_DEF_IM_BUTTON_HEIGHT			(27)

#define RMD_DEF_PRINT_BUTTON_POS_X			(495)
#define RMD_DEF_PRINT_BUTTON_POS_Y			(30-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_PRINT_BUTTON_WIDTH			(26)
#define RMD_DEF_PRINT_BUTTON_HEIGHT			(25)

#define RMD_DEF_VIEWER_POS_X				(0)
#define RMD_DEF_VIEWER_POS_Y				(60-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_VIEWER_WIDTH				(539)
#define RMD_DEF_VIEWER_HEIGHT				(294)

#define RMD_DEF_DOWN_BUTTON_POS_X			(460)
#define RMD_DEF_DOWN_BUTTON_POS_Y			(364-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_DOWN_BUTTON_WIDTH			(60)
#define RMD_DEF_DOWN_BUTTON_HEIGHT			(20)

#define RMD_DEF_FILE_LIST_POS_X				(0)
#define RMD_DEF_FILE_LIST_POS_Y				(390-RMD_DEF_TITLE_BAR_HEIGHT)
#define RMD_DEF_FILE_LIST_WIDTH				(503)
#define RMD_FILE_LIST_HEIGHT				(82)

#define RMD_RESIZE_MARGIN_HEIGHT			(151)//¡ ȵǴ  
#define RMD_DEF_FILE_BOTTOM					(117)

#define ID_RECVMEMO_FILE_ATTACH_LIST		(0xE001)
#define UM_RECVMEMO_DOWNLOAD				(WM_USER + 1091)
//-----------------------------------------------------------------------------

class CRecvMemoDlg : public CSkinDialog,
	private CAMSWnd,
	private CAMSWnd::PlacementHook
{
	DECLARE_DYNAMIC(CRecvMemoDlg)

public:
	BOOL Create();

	CRecvMemoDlg(UINT64 noteID, const NoteInfo& noteInfo);
	virtual ~CRecvMemoDlg();
	enum { IDD = IDD_MEMO_RECV_DIALOG };
	
protected:
	virtual void				DoDataExchange(CDataExchange* pDX); 
	virtual BOOL				OnInitDialog();
	virtual void				PostNcDestroy();
	virtual BOOL				PreTranslateMessage(MSG* pMsg);

	void ReadNote();

	BOOL						InitListFile();
	void						StopFlashAndAdjustFocus();
	
	DECLARE_MESSAGE_MAP()

public:
	void						__ResourceLoad(BOOL bInit = FALSE);
	void						ReSizeCtrl(void);	

	afx_msg void				OnSize(UINT nType, int cx, int cy);
	afx_msg void				OnBnClickedButtonReply();
	afx_msg void				OnBnClickedButtonReplyall();
	afx_msg void				OnBnClickedButtonForward();
	afx_msg void				OnBnClickedButtonDel();
	afx_msg void				OnBnClickedButtonIm();
	afx_msg void				OnBnClickedButtonPrt();
	afx_msg void				OnDestroy();
	afx_msg BOOL				OnEraseBkgnd(CDC* pDC);
	afx_msg void				OnPaint();
	afx_msg void				OnStnClickedFileDownload();
	afx_msg LRESULT				OnRecvMemoFileDownload(WPARAM wParam, LPARAM lParam);	
	afx_msg LRESULT             OnNcHitTest(CPoint point);

	LRESULT						OnBnClickedRecvMemoMenuButton(WPARAM wParam, LPARAM lParam);
	bool						IsInitializeSuccess(void);
	void						SetReadOnly( BOOL bStatus );
	void						DisplayFlashEffect();
	bool						IsCloseMsg( MSG* pMsg );
	
	//int							m_nFileCount;//÷ϰ
	CString						m_strFilename;//÷ ̸
	CString						m_strDownLoadUrl;// ٿε URL
	CString						m_strFileSize;//ϻ
	UINT64						GetNoteID(){ return m_lMemoID;}

	bool						OnResponseNoteSetReadStatus(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode);
	bool						OnResponseDeleteNote(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bResult);

private:
	HICON						m_hIcon;	
	CMemoView_explorerEx		m_ctrlMemoViewer;
	CNMImgButton				m_btnReply;
	CNMImgButton				m_btnAllReply;
	CNMImgButton				m_btnForward;
	CNMImgButton				m_btnIM;
	CNMImgButton				m_btnDel;
	CNMImgButton				m_btnPRT;
	CMemoRecvAttachWnd			m_listFiles;
	CRect						m_rcMemoInfoBorder;	//,   â 
	CRect						m_rcMemoViewBorder;	//޸𳻿 â  
	CRect						m_rcFileBorder;		//÷ â 
	UINT64						m_lMemoID;//޸ ID
	void						InitControls();
	enum SMARTEDITOR_STATUS{NONE= 0 ,SET_CONTENT=1, GET_CONTENT =2,};
	//LPDISPATCH					glpDisp;
	CString						m_strJSParam;
	void						SetSkin();
	CRect						m_rcButtonBG;
	CRect						m_rcFileListBG;
	bool						m_bInitializeSuccess;
	bool						m_bFlashFlag;
	const NoteInfo				m_noteInfo;
	bool						m_bReadStatus;
	trid_t						m_trid;
	int							m_noteCount;
	BOOL						m_bTopMost;
	void OnMenuTopMost();
	void OnMenuReply();
	void OnMenuAllReply();
	void OnMenuForward();
	void OnMenuRecvDel();
	void OnMenuChat();
	void _EnableAllBtnHandCurser();


public:
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
};
